// Test polimorphic unions more!
// $Id: t5.g,v 1.1 2002/01/28 11:14:29 malekith Exp $
extern_c void print_string(string);
extern_c void print_int(int);

union <'a>list {
	void Nil;
	*['a, <'a>list] Cons;
}

int length(<'a>list l)
{
	switch l {
	case Nil[]:
		return 0;
	case Cons[hd, tl]:
		return 1 + length(tl);
	}
}

void iter(*('a) -> void f, <'a>list l)
{
	switch l {
	case Nil[]:
		return;
		
	case Cons[hd, tl]:
		f(hd);
		iter(f, tl);
	}
}

<'b>list map(*('a) -> 'b f, <'a>list l)
{
	switch l {
	case Nil[]:
		return Nil[];		

	case Cons[hd, tl]:
		return Cons[f(hd), map(f, tl)];
	}
}

<'a>list concat(<'a>list x, <'a>list y)
{
	switch x {
	case Nil[]:
		return y;
	case Cons[hd, tl]:
		return Cons[hd, concat(tl, y)];
	}
}

<'a>list qsort(*('a, 'a) -> int cmp, <'a>list l)
{
	'a m;

	*[<'a>list, <'a>list] split(<'a>list r1, <'a>list r2, <'a>list lst) {
		switch lst {
		case Nil[]:
			return [r1, r2];
		case Cons[x, xs]:
			if (cmp(x, m) < 0) {
				return split(Cons[x, r1], r2, xs);
			} else {
				return split(r1, Cons[x, r2], xs);
			}
		}
	}

	switch l {
	case Nil[]:
		return l;
	case Cons[hd, r]:
		m = hd;
		switch (split(Nil[], Nil[], r)) {
		case [r1, r2]:
			concat(qsort(cmp, r1), Cons[m, qsort(cmp, r2)]);
		}
	}
}

void print_int_list(<int>list l)
{
	void print(int x) 
	{
		print_int(x);
		print_string(",");
	}

	print_string("[");
	iter(print, l);

	print_string("] ");
}

int main() export_as "main"
{
	<int>list i;
	int cnt = 0;
	int adder(int x) { cnt = (cnt + 1) % 4; return x + cnt; }
	
	i = Cons[3, Cons[1, Cons[2, Nil]]];
	i = concat(map(fun (int x) -> int is ((3 - x) * 2), i), i);
	i = concat(map(fun (int x) -> int is ((3 - x) * 2), i), i);
	print_int_list(i);
	i = map(adder, i);
	print_int_list(i);
	print_int_list(qsort(fun (int x, int y) -> int is (x - y), i));
	print_int_list(qsort(fun (int x, int y) -> int is (y - x), i));

	print_string(".\n");
	return 0;
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: [6,-2,2,0,4,2,0,4,2,3,1,2,] [6,1,4,1,4,5,2,5,2,6,3,3,] [1,1,2,2,3,3,4,4,5,5,6,6,] [6,6,5,5,4,4,3,3,2,2,1,1,] .
 */
